module MySQLNoIo
  module Wraps
    # Stops the database slave entirely for your command
    class DeactivatedSlave
      def initialize mysql
        @mysql = mysql
      end

      def execute &block
        @mysql.query('STOP SLAVE;')
        yield
      ensure
        @mysql.query('START SLAVE;')
      end
    end
  end
end

